package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.ReturObatService;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.vo.PelayananPasienVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;

@RestController
@RequestMapping("/retur-obat")
public class ReturObatController extends LocaleController<PelayananPasienVO> {

	private static final Logger LOGGER = getLogger(ReturObatController.class);

	@Autowired
	private ReturObatService service;

	@RequestMapping(value = "/find-retur-by-struk")
	@ResponseBody
	public List<Map<String, Object>> findReturStruk(@RequestParam(value = "ruanganId") Integer ruanganId,
			@RequestParam(value = "noResep") String noResep, @RequestParam(value = "noCm") String noCm,
			@RequestParam(value = "tglAwal") String tglAwal, @RequestParam(value = "tglAhir") String tglAhir) {
		return service.getReturStrukResep(ruanganId, noResep, noCm, tglAwal, tglAhir);
	}

	@RequestMapping(value = "/get-ruangan-instalasi-farmasi")
	@ResponseBody
	public List<Map<String, Object>> getRuanganInstalasiFarmasi() {
		return service.getRuanganFarmasi();
	}

	@RequestMapping(value = "/get-detail-retur", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getDetailRetur(@RequestParam(value = "noRec") String noRec,
			@RequestParam(value = "noStruk") String noStruk, @RequestParam(value = "noSbmLast") String noSbmLast,
			HttpServletRequest request) {
		try {
			Map<String, Object> result = service.detailReturResep(noRec, noStruk, noSbmLast);
			if (CommonUtil.isNotNullOrEmpty(result)) {
				if (result.get("listData").toString().equalsIgnoreCase("Tidak ada barang yang dapat diretur")) {
					Map<String, String> headerMessageCustom = new HashMap<>();
					headerMessageCustom.put("label-success", "Tidak ada barang yang dapat diretur");
					return getJsonResponse(null, CREATED, headerMessageCustom);
				} else {
					mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
					return getJsonResponse(result, OK, mapHeaderMessage);
				}
			} else {
				Map<String, String> headerMessageCustom = new HashMap<>();
				headerMessageCustom.put("label-success", "Tidak bisa di retur");
				return getJsonResponse(result, CREATED, headerMessageCustom);
			}
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when detailReturResep", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when detailReturResep", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

}
